/* Linked List */

#include <iostream>
#include <memory>

using namespace std;

class Nodey {
	public:

      int info;
      shared_ptr<Nodey> next;

      Nodey(int);
};


class Listy {
	shared_ptr<Nodey> head;
    
    public:

    void push(int);
    void addAtEnd(int);
    void printList();
    void connect(int, int);
};

Nodey::Nodey(int num){
   info = num;
}

void Listy::push(int num){
	shared_ptr<Nodey> tmp = make_shared<Nodey>(num);
	tmp->next = head;
	head = tmp;
}

void Listy::addAtEnd(int num){
	shared_ptr<Nodey> tmp = make_shared<Nodey>(num);
	if (head == NULL){
		head = tmp;
	}
	shared_ptr<Nodey> current = head;
	while(current->next != NULL){ 
		current = current->next;
	}
	current->next = tmp;

}

void Listy::connect(int num1, int num2){
    shared_ptr<Nodey> tmp;
    shared_ptr<Nodey> current = head;
    while((current->next != NULL) && (current->info != num1)) { 
        current = current->next;
    }
    if (current->info == num1){
        tmp = current;
        //cout << "Found " << num1;
    }
    // now march through and find num2
    current = head;
    while((current->next != NULL) && (current->info != num2)) { 
        current = current->next;
    }
    if (current->info == num2) {
        tmp->next = current;
    }
}

void Listy::printList(){
	shared_ptr<Nodey> nextPtr = head;
    int i = 1;
	while ((nextPtr != NULL) && (i++ < 50)){
		cout << nextPtr->info << endl;
		nextPtr = nextPtr->next;
	}
}


int main(){
	shared_ptr<Listy> myList = make_shared<Listy>();
    shared_ptr<Listy> myLoop = make_shared<Listy>();

    myList->push(10);
    myList->push(20);
    myList->push(30);
    myList->addAtEnd(8);
    myList->addAtEnd(5);
    myList->addAtEnd(1);
    myList->printList();
    cout << "\n\n\n\n\n\n";

    myLoop->push(10);
    myLoop->push(20);
    myLoop->push(30);
    myLoop->addAtEnd(8);
    myLoop->addAtEnd(5);
    myLoop->addAtEnd(1);
    myLoop->connect(1,20);
    myLoop->printList();



    /* PARTNER TASK */

    /* // TODO:  add delete method
    myList->deleteNode(10);
    myList->deleteNode(1);
    myList->deleteNode(30);
    // should print 20    5
    myList->printList();
    */

    /* //TODO: add addAfter method
    // return true if the number was found and an add took place
    // false otherwise
    cout << myList->addAfter(20, 18);  // add after 20 the number 18
    cout << myList->addAfter(15, 11);  // return false
    cout << myList->addAfter(18, 12);
    cout << myList->addAfter(1, 99);
    myList->printList();
   
    */
    
}